// In this header file we subclass MainWindow in order to add extra handling code to its closeEvent()
// ( tried adding all this code in main.cpp, but that caused an "undefined reference to `vtable for MainWindowImpl'" error )

// In order for this to work, I had to add the following line to CoBra_Disk_Image_Tool.pro:
// HEADERS += MainWindow/MainWindowImpl.h


#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include "ConfirmDialog.h"
#include "MainWindow.h"
#include "HelpWindow.h"


extern HelpWindow* hlpp;		// pointer to help window defined in MainWindow.ui.h


namespace DEVIL {

	extern bool hlp_open;		// flag showing if help window was opened

}


class MainWindowImpl : public MainWindow {

	Q_OBJECT

    public:
	MainWindowImpl( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel ) : MainWindow(parent, name, fl) {}

    protected:
	void closeEvent (QCloseEvent *event) {

		if (DEVIL::hlp_open) {
			hlpp->close();
		}

		ConfirmDialog dlg(0,0,1,Qt::WStyle_Customize | Qt::WStyle_Title | Qt::WSubWindow );	// create the error popup message window
		dlg.setCaption("Are you sure?");
		dlg.textLabel1->setText("Are you sure you want to quit?");
		dlg.pushButton1->setText("Yes");
		if (dlg.exec()) {
			event->accept();
		} else {
			event->ignore();
		};
	}

};
