char* USAGE = 
"\n\n===============================================================================\n\
| *********** CoBra DEVIL raw disk image reader / writer for Linux ********** |\n\
|                CREATED BY: CoBra @ RomanianHomeComputer                     |\n\
===============================================================================\n\
\n\
                 PLEASE READ THIS CAREFULLY BEFORE USING\n\
\n\
######################### PURPOSE OF THIS PROGRAM #############################\n\
\n\
This program reads and writes RAW FORMAT floppy images of DSDD 720K CoBra Devil\n\
disks with 80 tracks, 18 sectors/track/side (36 sectors/track), 256 bytes/sector\n\
and displays a detailed directory structure and catalog listing. It can extract\n\
selected catalog entries from the floppy image to an external .TAP file\n\
according to the Spectrum .TAP file format specifications by Gerton Lunter.\n\
 It can also write a .TAP file (existent in your Linux filesystem) into the\n\
filesystem of the disk image. A full list of commands is given below.\n\
\n\
 The disk image format must have the 256-byte sectors in their physical order,\n\
starting with side 0 sectors of a track and continuing with side 1 sectors of it.\n\
Please note that the physical sector order is 1 10 2 11 3 12 ... 9 18 (interleave 2)\n\
and that is also the order in which sectors are read/written.\n\
All tracks must be saved like this in physical order (track#0, track#1 ...).\n\
\n\
 A Devil RAW floppy image file can be generated from an already existing Teledisk\n\
floppy image using the TD02RAW utility that comes with this program\n\
(it uses the SAMDisk utility by Simon Owen run under Linux Wine, (Wine must be\n\
configured as Windows 2000 or up).\n\
 An empty Devil RAW floppy image can also be created with this program (using\n\
the -c command), and then applications available as .TAP files can be written to it.\n\
 Since virtualization software is usually too stupid to work with 256 bytes/sector\n\
floppy disks, generating a Devil RAW floppy image in a virtual DOS machine will\n\
most likely never work.\n\
\n\
########################### SYNTAX DESCRIPTION ################################\n\
\n\
 The general command line syntax for this program is:\n\
---------------------------------------------------\n\
executable command /path/to/devildisk.img   ...\n\
---------------------------------------------------\n\
          | arg#1 |        arg#2         |  ...\n\
\n\
There is one exception, the -t command which expects a .TAP file name as its\n\
second argument.\n\
\n\
 Commands supported are:\n\
	-c (create disk image),\n\
	-l (list contents),\n\
	-x (extract file(s)),\n\
	-w (write file(s) to disk image),\n\
	-d (delete file(s)),\n\
	-g (defragment free space on disk image),\n\
	-r0 (set R/O-R/W attribute to R/W\n\
	-r1 (set R/O-R/W attribute to R/O\n\
	-s0 (set DIR/SYS attribute to DIR, visible with CAT),\n\
	-s1 (set DIR/SYS attribute to SYS, non-visible with CAT),\n\
	-i (interleave disk image, this program only works with interleaved images),\n\
	-di (deinterleave disk image before converting them to HFE,\n\
	    HxCFloppyEmulator.exe expects RAW images to be non-interleaved,\n\
	    the interleave factor will be have to be entered in the\n\
	    \"RAW File format configuration\" window before exporting to HFE)\n\
	-k (check disk image for some logical format errors - not implemented yet!!).\n\
	-t (list contents of a .TAP file).\n\
\n\
The following options can be used with SOME commands (see each command syntax):\n\
	-log - a detailed operation log file will be generated.\n\
	-ver - verbose operation, detailed messages will be displayed during execution.\n\
	-deb - debug information will be displayed, beside the normally displayed info:\n\
	     - a raw hex text dump of all directory records, in logical sector order\n\
	       containing the file names in clear for records not deleted,\n\
	     - a directory record allocation table in logical sector order, where\n\
	       a \"0\" means the record is free (available) and\n\
	       a \"1\" means it is allocated,\n\
\n\
\n\
 The create command line syntax is:\n\
------------------------------------------\n\
executable   -c    /path/to/devildisk.img \n\
------------------------------------------\n\
          | arg#1 |        arg#2         |\n\
\n\
\n\
 The list command line syntax is:\n\
--------------------------------------------------\n\
executable   -l    /path/to/devildisk.img  [-deb] \n\
--------------------------------------------------\n\
          | arg#1 |        arg#2         | arg#3 |\n\
\n\
\n\
 The extract command line syntax is:\n\
-----------------------------------------------------------------------\n\
executable   -x    /path/to/devildisk.img  range  [ -log|-ver [-deb] ] \n\
-----------------------------------------------------------------------\n\
          | arg#1 |        arg#2         | arg#3 |   arg#4   | arg#5  |\n\
\n\
\n\
 The write file command line syntax is:\n\
----------------------------------------------------------------------------\n\
executable   -w    /path/to/devildisk.img /path/to/file.tap [ -ver  [-deb] ]\n\
----------------------------------------------------------------------------\n\
          | arg#1 |         arg#2        |      arg#3      | arg#4 | arg#5 |\n\
\n\
\n\
 The delete command line syntax is:\n\
----------------------------------------------------------------\n\
executable   -d    /path/to/devildisk.img  range  [-ver [-deb]]]\n\
----------------------------------------------------------------\n\
          | arg#1 |         arg#2        | arg#3 |arg#4| arg#5 |\n\
\n\
\n\
 The defragment command line syntax is:\n\
----------------------------------------------------------------\n\
executable   -g    /path/to/devildisk.img  [-ver [-deb]]]\n\
----------------------------------------------------------------\n\
          | arg#1 |         arg#2        | arg#3 |arg#4|\n\
\n\
\n\
 The set attribute command line syntax is:\n\
------------------------------------------------------------------------\n\
executable -r0|-r1|-s0|-s1 /path/to/devildisk.img  range  [-ver [-deb]]]\n\
------------------------------------------------------------------------\n\
          |     arg#1     |         arg#2        | arg#3 |arg#4| arg#5 |\n\
\n\
\n\
 The interleave command line syntax is:\n\
----------------------------------------------------------\n\
executable   -i    /path/to/devildisk.img [ -ver ]\n\
----------------------------------------------------------\n\
          | arg#1 |         arg#2        | arg#3 |\n\
\n\
\n\
 The deinterleave command line syntax is:\n\
----------------------------------------------------------\n\
executable   -di   /path/to/devildisk.img [ -ver ] ]\n\
----------------------------------------------------------\n\
          | arg#1 |         arg#2        | arg#3 |\n\
\n\
\n\
 The .TAP list command line syntax is:\n\
----------------------------------------------------------\n\
executable   -t   /path/to/tapfile.tap\n\
----------------------------------------------------------\n\
          | arg#1 |         arg#2        |\n\
\n\
\n\
NOTE: 1. FOR -x, -d and -r0|-r1|-s0|-s1 COMMANDS, arg#3 is a range of\n\
	 catalog entries in the form \"nn\" or \"nn-nn\", where nn is\n\
	 a 1-digit or 2-digit number between 0 and 76\n\
	 (there can be max. 77 catalog entries).\n\
      2. FOR THE -w COMMAND, arg#3 is the full path to a .TAP file in your\n\
         (Linux) computer filesystem, to be written to the disk image.\n\
      3. FOR THE -l COMMAND, arg#3 is optional and can only be \"-deb\".\n\
      3. FOR THE -i and -di COMMANDS, arg#3 is optional and can only be \"-ver\".\n\
      5. FOR THE -c and -t COMMANDS, arg#3 is never used.\n\
      6. Command parameters must be in the exact position as specified\n\
         by the syntax. For instance, with the -x command, the -deb option\n\
         must always be arg#5. That means -log or -ver must be used first.\n\
\n\
 The disk image file name MUST end in an .img extension.\n\
\n\
 The -c command creates an empty formatted disk image (all sectors filled\n\
with the E5 byte).\n\
\n\
 The -l command displays the detailed contents of the disk image file.\n\
\n\
 The -x command will extract a user specified range of catalog entries\n\
(the range can be one single entry or multiple consecutive entries) to an\n\
external .TAP file which can then be loaded in any Spectrum emulator or in\n\
a physical Spectrum compatible (e.g. CoBra) by playing it as audio.\n\
 When specifying the range we should have in mind the data sequence of a\n\
standard Spectrum application, which usually is \"Prog: Code: Code: ...\"\n\
Sometimes it can also be \"Prog: Prog: Code: Code:\" but whatever that is\n\
it should be precisely known before attempting to extract an application\n\
from the disk image, so we can correctly specify the range of catalog entries.\n\
 If the range is not correctly specified, the extracted .TAP file may end up\n\
containing an incomplete Spectrum application which will not load correctly\n\
later on.\n\
\n\
 The -w command will write the contents of a .TAP file existent on your (Linux)\n\
filesystem into the disk image specified. The writing will only take place if\n\
a continuous range of disk blocks, (i.e. full tracks) big enough to contain the\n\
whole contents of the .TAP file, can be found on the disk image. The writing\n\
will put all data blocks from the .TAP file, in the same consecutive order,\n\
on the consecutive free tracks found on the disk image.\n\
\n\
 The -d command will delete a user specified range of catalog entries\n\
(the range can be one single entry or multiple consecutive entries) from\n\
the disk image file. The inevitable effect of this will be disk fragmentation\n\
which later on will affect the writing of another application from a .TAP file.\n\
The proper way to do the deletion should involve an automatic defragmentation,\n\
but so far I did have the time to implement this :( sorry ).\n\
\n\
 The -i command will take a RAW DEVIL disk image (NNNN.img) with sectors presumed\n\
to be non-interleaved and generate a new image (NNNN_interleaved.img) having\n\
sectors saved in their normal interleaved order according to the DEVIL disk format.\n\
After converting from .TD0 to RAW using HxCFloppyEmulator.exe, the RAW image\n\
must be first interleaved before manipulating it with this program, otherwise\n\
data errors will occur.\n\
\n\
 The -di command will take a RAW DEVIL disk image (NNNN.img) with sectors presumed\n\
to be interleaved and generate a new image (NNNN_deinterleaved.img) having\n\
sectors saved in the order of their physical numbers (non-interleaved.\n\
Before converting from RAW to HFE using HxCFloppyEmulator.exe, the RAW image\n\
must be first deinterleaved, otherwise the HFE image will not be usable.\n\
\n\
 The -r0 command will set the writable attribute to R/W for the data blocks\n\
in the specified range (the range has the same meaning as for the -d command).\n\
Blocks with this attribute can be deleted using the ERASE command or the STAT utility.\n\
\n\
 The -r1 command will set the writable attribute to R/O for the data blocks\n\
in the specified range (the range has the same meaning as for the -d command).\n\
Blocks with this attribute can NOT be deleted.\n\
\n\
 The -s0 command will set the visibility attribute to DIR for the data blocks\n\
in the specified range (the range has the same meaning as for the -d command).\n\
Blocks with this attribute can be listed using the DEVIL command CAT.\n\
\n\
 The -s1 command will set the visibility attribute to SYS for the data blocks\n\
in the specified range (the range has the same meaning as for the -d command).\n\
Blocks with this attribute cannot be listed using the DEVIL command CAT.\n\n\
################################## END ########################################\n\
\n";
