#!/bin/sh

# This script would be used to rebuild Qt3.3.8 with static libraries
# and install it in /usr/local/
# You need to already have ALL dependencies required for this build !!

# Run as root, of course
ROOT_UID=0 # Only users with $UID 0 have root privileges
E_NOTROOT=67 # Non root exit error
DIAL=Xdialog
prgname=`basename $0`
if [ "$UID" -ne "$ROOT_UID" ]; then
 $DIAL --no-close --title "WARNING" \
       --msgbox "This script must be run as root !!! \nTry this: sudo $prgname" 0 0
 exit $E_NOTROOT
fi

wget http://snapshot.debian.org/archive/debian-archive/20120328T092752Z/debian/pool/main/q/qt-x11-free/qt-x11-free_3.3.8b-5.diff.gz
wget http://snapshot.debian.org/archive/debian-archive/20120328T092752Z/debian/pool/main/q/qt-x11-free/qt-x11-free_3.3.8b-5.dsc
wget http://snapshot.debian.org/archive/debian-archive/20120328T092752Z/debian/pool/main/q/qt-x11-free/qt-x11-free_3.3.8b.orig.tar.gz

echo -e "\n\n######################################################\n############## UNPACKING QT SOURCES ##################\n######################################################\n"

dpkg-source -x qt-x11-free_3.3.8b-5.dsc
cd qt-x11-free-3.3.8b

echo -e "\n\n######################################################\n############## RUNNING CONFIGURE #####################\n######################################################\n"

./configure -prefix /usr/local/Qt3.3.8-static \
	    -static \
	    -qt-gif \
	    -qt-libpng \
	    -qt-libjpeg \
	    -qt-libmng \
	    -qt-zlib \
	    -plugin-sql-mysql \
	    -plugin-sql-psql \
	    -qt-sql-sqlite \
	    -thread \
	    -largefile \
	    -fast \
	    -verbose \
	    -no-nas-sound \
	    -no-sm \
	    -no-xinerama \
	    -no-xcursor \
	    -no-xrandr \
	    -xrender \
	    -xft \
	    -no-tablet \
	    -no-xkb \
	    -dlopen-opengl

echo -e "\n\n######################################################\n############## RUNNING MAKE ##########################\n######################################################\n"

make

echo -e "\n\n######################################################\n############## RUNNING MAKE INSTALL ##################\n######################################################\n"

make install

exit 0